<?php  
class ControllerCatalogSitemap extends Controller {
	public function index() {
		$this->load->language('catalog/sitemap');

		$this->document->title = $this->language->get('heading_title');
		
		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=catalog/sitemap&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
   		
		$this->data['heading_title'] = $this->language->get('heading_title');
   		$this->data['entry_description'] =  $this->language->get('entry_description');
		$this->data['entry_priority'] =  $this->language->get('entry_priority');
		$this->data['entry_frequency'] =  $this->language->get('entry_frequency');
		$this->data['button_save'] =  $this->language->get('button_save');
		
   		if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];
		
			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=catalog/sitemap/creat&token=' . $this->session->data['token'];
		
		
		$this->template = 'catalog/sitemap.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}
	
	
	public function creat() {
		$urls=array();
		
		$this->load->model('tool/seo_url');
		$this->load->model('catalog/sitemap');
	
		foreach ($this->model_catalog_sitemap->getInformations() as $result) {
		
      	$urls[]=array(
        	'url'      =>$this->model_tool_seo_url->rewrite($this->url('information/information&information_id=' . $result['information_id'])), 
        	'name'      => $result['title']
			);
		};
	
		$results = $this->model_catalog_sitemap->getCategorieForSitemap(0);

		$current_path = '';
		foreach ($results as $result) {	
			if (!$current_path) {
				$new_path = $result['category_id'];
			} else {
				$new_path = $current_path . '_' . $result['category_id'];
			}
			$urls[]=array(
        	'url'      =>$this->model_tool_seo_url->rewrite($this->url('product/category&path=' . $new_path)), 
        	'name'      => $result['name']
			);
		}
	
		$results1 = $this->model_catalog_sitemap->getAllProducts();
	
		foreach ($results1 as $result) {
			$urls[]=array(
        	'url'      =>$this->model_tool_seo_url->rewrite($this->url('product/product&product_id=' . $result['product_id'])), 
        	'name'      => $result['model']
			);
		}
		
		
		$sitemap =new Sitemaps();
		$sitemap->createSitemap ($urls, $this->request->post['priority'], $this->request->post['freq'] );
		$this->load->language('catalog/sitemap');
		$this->session->data['success'] = $this->language->get('text_success');
		$this->index();
	}
	
	public function url($route) {
		return HTTP_CATALOG . 'index.php?route=' . str_replace('&amp;', '&', $route);
  	}
}
?>